;;; popup.clp
;;; Demonstrates popup menus on a canvas

(defglobal ?*main-frame* = 0)
(defglobal ?*canvas* = 0)
(defglobal ?*popup-menu* = 0)

;;; Popup-menu callback
(deffunction menu-callback (?id)
  (printout t "Popup menu callback." crlf)
  (bind ?event-id (panel-item-get-command-event))
  (bind ?sel (command-event-get-selection ?event-id))
  (printout t "Selection was " ?sel crlf)
)

(deffunction on-menu-command (?frame ?id)
 (switch ?id
  (case 200 then (message-box "CLIPS for wxWindows Demo
by Julian Smart (c) 1993" "About wxWindows CLIPS Demo"))
  (case 1 then (window-delete ?frame))
  )
)

(deffunction on-event (?canvas ?event)
  (bind ?dc (canvas-get-dc ?canvas))
  (bind ?x (mouse-event-position-x ?event))
  (bind ?y (mouse-event-position-y ?event))
  (if (eq 1 (mouse-event-is-button ?event)) then
   (window-popup-menu ?canvas ?*popup-menu* ?x ?y))
)

;;; Test program to create a frame and canvas
(deffunction app-on-init ()
;  (unwatch all)

  (bind ?*main-frame* (frame-create 0 "Hello wxCLIPS!" -1 -1 500 460))
  (frame-create-status-line ?*main-frame*)
  (frame-set-status-text ?*main-frame* "Welcome to wxCLIPS")
  
  (bind ?*canvas* (canvas-create ?*main-frame*))
  (window-add-callback ?*canvas* OnEvent on-event)
  
  ;;; Create a new popup menu
  (bind ?*popup-menu* (menu-create "" menu-callback))
  (menu-append ?*popup-menu* 1 "One")
  (menu-append ?*popup-menu* 2 "Two")
  (menu-append ?*popup-menu* 3 "Three")

  (window-add-callback ?*main-frame* OnMenuCommand on-menu-command)

  ;;; Make a menu bar
  (bind ?file-menu (menu-create))
  (menu-append ?file-menu 3 "&Quit")

  (bind ?help-menu (menu-create))
  (menu-append ?help-menu 200 "&About")

  (bind ?menu-bar (menu-bar-create))
  (menu-bar-append ?menu-bar ?file-menu "&File")
  (menu-bar-append ?menu-bar ?help-menu "&Help")

  (frame-set-menu-bar ?*main-frame* ?menu-bar)

  ;;; Make a panel and panel items
  (window-centre ?*main-frame* wxBOTH)

  (window-show ?*main-frame* 1)
  ?*main-frame*)

